/*
 * Copyright (C) 1996, jack
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: _cmbctyp.c,v 1.1 1996/07/09 08:41:59 jack Exp $ */

#include <mbctype.h>
#include <mbprvt.h>

#define MBCNUM ((1<<8)+1)

unsigned char __c_mbctype[MBCNUM] =
{
  0, /* EOF */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* 00-0f */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* 10-1f */

  _MB_CBLANK, /* 20 */
  _MB_CPUNCT, /* 21 */
  _MB_CPUNCT, /* 22 */
  _MB_CPUNCT, /* 23 */
  _MB_CPUNCT, /* 24 */
  _MB_CPUNCT, /* 25 */
  _MB_CPUNCT, /* 26 */
  _MB_CPUNCT, /* 27 */
  _MB_CPUNCT, /* 28 */
  _MB_CPUNCT, /* 29 */
  _MB_CPUNCT, /* 2a */
  _MB_CPUNCT, /* 2b */
  _MB_CPUNCT, /* 2c */
  _MB_CPUNCT, /* 2d */
  _MB_CPUNCT, /* 2e */
  _MB_CPUNCT, /* 2f */

  _MB_CDIGIT, /* 30 */
  _MB_CDIGIT, /* 31 */
  _MB_CDIGIT, /* 32 */
  _MB_CDIGIT, /* 33 */
  _MB_CDIGIT, /* 34 */
  _MB_CDIGIT, /* 35 */
  _MB_CDIGIT, /* 36 */
  _MB_CDIGIT, /* 37 */
  _MB_CDIGIT, /* 38 */
  _MB_CDIGIT, /* 39 */
  _MB_CPUNCT, /* 3a */
  _MB_CPUNCT, /* 3b */
  _MB_CPUNCT, /* 3c */
  _MB_CPUNCT, /* 3d */
  _MB_CPUNCT, /* 3e */
  _MB_CPUNCT, /* 3f */

  _MB_CPUNCT, /* 40 */
  _MB_CALPHA, /* 41 */
  _MB_CALPHA, /* 42 */
  _MB_CALPHA, /* 43 */
  _MB_CALPHA, /* 44 */
  _MB_CALPHA, /* 45 */
  _MB_CALPHA, /* 46 */
  _MB_CALPHA, /* 47 */
  _MB_CALPHA, /* 48 */
  _MB_CALPHA, /* 49 */
  _MB_CALPHA, /* 4a */
  _MB_CALPHA, /* 4b */
  _MB_CALPHA, /* 4c */
  _MB_CALPHA, /* 4d */
  _MB_CALPHA, /* 4e */
  _MB_CALPHA, /* 4f */

  _MB_CALPHA, /* 50 */
  _MB_CALPHA, /* 51 */
  _MB_CALPHA, /* 52 */
  _MB_CALPHA, /* 53 */
  _MB_CALPHA, /* 54 */
  _MB_CALPHA, /* 55 */
  _MB_CALPHA, /* 56 */
  _MB_CALPHA, /* 57 */
  _MB_CALPHA, /* 58 */
  _MB_CALPHA, /* 59 */
  _MB_CALPHA, /* 5a */
  _MB_CPUNCT, /* 5b */
  _MB_CPUNCT, /* 5c */
  _MB_CPUNCT, /* 5d */
  _MB_CPUNCT, /* 5e */
  _MB_CPUNCT, /* 5f */

  _MB_CPUNCT, /* 60 */
  _MB_CALPHA, /* 61 */
  _MB_CALPHA, /* 62 */
  _MB_CALPHA, /* 63 */
  _MB_CALPHA, /* 64 */
  _MB_CALPHA, /* 65 */
  _MB_CALPHA, /* 66 */
  _MB_CALPHA, /* 67 */
  _MB_CALPHA, /* 68 */
  _MB_CALPHA, /* 69 */
  _MB_CALPHA, /* 6a */
  _MB_CALPHA, /* 6b */
  _MB_CALPHA, /* 6c */
  _MB_CALPHA, /* 6d */
  _MB_CALPHA, /* 6e */
  _MB_CALPHA, /* 6f */

  _MB_CALPHA, /* 70 */
  _MB_CALPHA, /* 71 */
  _MB_CALPHA, /* 72 */
  _MB_CALPHA, /* 73 */
  _MB_CALPHA, /* 74 */
  _MB_CALPHA, /* 75 */
  _MB_CALPHA, /* 76 */
  _MB_CALPHA, /* 77 */
  _MB_CALPHA, /* 78 */
  _MB_CALPHA, /* 79 */
  _MB_CALPHA, /* 7a */
  _MB_CPUNCT, /* 7b */
  _MB_CPUNCT, /* 7c */
  _MB_CPUNCT, /* 7d */
  _MB_CPUNCT, /* 7e */
  0, /* 7f */

  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* 80-8f */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* 90-9f */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* a0-af */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* b0-bf */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* c0-cf */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* d0-df */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* e0-ef */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* f0-ff */
};
